unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Spin, ComCtrls, Menus;

const
  MaxFood = 8;
  MatrSize = 200;

type
  TUnit = class(TObject)
     body, nears, food : byte;
  end;

  TForm1 = class(TForm)
    Image1: TImage;
    ButtonNext: TButton;
    ButtonPlay: TButton;
    TrackBar1: TTrackBar;
    Label1: TLabel;
    RadioGroup1: TRadioGroup;
    b1: TCheckBox;
    b4: TCheckBox;
    b2: TCheckBox;
    b7: TCheckBox;
    B0: TCheckBox;
    b6: TCheckBox;
    b8: TCheckBox;
    b3: TCheckBox;
    b5: TCheckBox;
    RadioGroup2: TRadioGroup;
    d1: TCheckBox;
    d4: TCheckBox;
    d2: TCheckBox;
    d7: TCheckBox;
    d0: TCheckBox;
    d6: TCheckBox;
    d8: TCheckBox;
    d3: TCheckBox;
    d5: TCheckBox;
    Memo1: TMemo;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    Saveas1: TMenuItem;
    EXIT1: TMenuItem;
    N1: TMenuItem;
    Help1: TMenuItem;
    ButtonPause: TButton;
    ButtonReset: TButton;
    LabelPepsi: TLabel;
    RadioButton1: TRadioButton;
    RadioButtonBlue: TRadioButton;
    Timer1: TTimer;
    ButtonNew: TButton;
    ButtonOpen: TButton;
    ButtonSave: TButton;
    ButtonSaveAs: TButton;
    ButtonExit: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ButtonNextClick(Sender: TObject);
    procedure ButtonPlayClick(Sender: TObject);
    procedure Memo1Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure ButtonResetClick(Sender: TObject);
    procedure ButtonNewClick(Sender: TObject);
    procedure ButtonExitClick(Sender: TObject);
    procedure ButtonOpenClick(Sender: TObject);
    procedure ButtonSaveClick(Sender: TObject);
    procedure ButtonSaveAsClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ButtonPauseClick(Sender: TObject);
    procedure b4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Body : array[-MatrSize-1..MatrSize+1, -MatrSize-1..MatrSize+1] of boolean;
    Future : array[-MatrSize-1..MatrSize+1, -MatrSize-1..MatrSize+1] of boolean;
    Nears : array[-MatrSize-1..MatrSize+1, -MatrSize-1..MatrSize+1] of byte;
    Color : array[-MatrSize-1..MatrSize+1, -MatrSize-1..MatrSize+1] of byte;
    Age : longint;
    b, d : array[0..8] of boolean;
    WorldSizeX, WorldSizeY, CellSize : integer;
    FileName : string;
    procedure Pepsi;
    procedure AddCell(x, y : integer);
    procedure AddGCell(x, y : integer);
    procedure AddYCell(x, y : integer);
    procedure DieCell(x, y : integer);
    procedure Die1Cell(x, y : integer);
    procedure DrawCell(x, y : integer);
    procedure DrawEmpty(x, y : integer);
    procedure ClearScreen;
    procedure ClearAll;
    procedure ChangeRules;
    procedure MatrOpen;
    procedure MatrSave;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Pepsi;
var i1, i2, i3, i4, gr1, yel1     : integer;
begin
  for i2 := -WorldSizeY to WorldSizeY do
  for i1 := -WorldSizeX to WorldSizeX do
    if Body[i1, i2] then
    begin
      Nears[i1-1, i2-1] := Nears[i1-1, i2-1] + 1;
      Nears[i1, i2-1] := Nears[i1, i2-1] + 1;
      Nears[i1+1, i2-1] := Nears[i1+1, i2-1] + 1;
      Nears[i1-1, i2] := Nears[i1-1, i2] + 1;
      Nears[i1+1, i2] := Nears[i1+1, i2] + 1;
      Nears[i1-1, i2+1] := Nears[i1-1, i2+1] + 1;
      Nears[i1, i2+1] := Nears[i1, i2+1] + 1;
      Nears[i1+1, i2+1] := Nears[i1+1, i2+1] + 1;
    end;
  for i2 := -WorldSizeY to WorldSizeY  do
  for i1 := -WorldSizeX to WorldSizeX  do
  begin
    if Body[i1, i2] then
    begin
      if D[Nears[i1, i2]] then Die1Cell(i1, i2);
    end
    else
    if B[Nears[i1, i2]] then
    begin
      gr1 := 0;  yel1 := 0;
      for i3 := -1 to 1 do
      for i4 := -1 to 1 do
      if Body[i1+i3, i2+i4] then
        if Color[i1+i3, i2+i4] = 1 then inc(gr1)
        else inc(yel1);
      if gr1 = yel1 then gr1 := gr1 + Random(2);
      if gr1 > yel1 then AddGCell(i1, i2)
      else AddYCell(i1, i2);
    end;
  end;
  for i2 := -WorldSizeY to WorldSizeY  do
  for i1 := -WorldSizeX to WorldSizeX  do
  begin
    Nears[i1, i2] := 0;
    if Future[i1, i2] and not Body[i1, i2] then AddCell(i1, i2);
    if not Future[i1, i2] and Body[i1, i2] then DieCell(i1, i2);
  end;
  Inc(Age);
  LabelPepsi.Caption := IntToStr(Age);
  LabelPepsi.Refresh;
end;

procedure TForm1.AddCell(x, y : integer);
begin
  Body[x, y] := true;
  DrawCell(x, y);
end;

procedure TForm1.AddGCell(x, y : integer);
begin
  Future[x, y] := true;
  Color[x, y] := 1;
end;

procedure TForm1.AddYCell(x, y : integer);
begin
  Future[x, y] := true;
  Color[x, y] := 2;
end;

procedure TForm1.DieCell(x, y : integer);
begin
  Body[x, y] := false;
  DrawEmpty(x, y);
  Color[x, y] := 0;
end;

procedure TForm1.Die1Cell(x, y : integer);
begin
  Future[x, y] := false;
end;

procedure TForm1.DrawCell(x, y : integer);
var x1, y1 : integer;
begin
  x1 := (x + WorldSizeX) * CellSize;
  y1 := (y + WorldSizeY) * CellSize;
  Image1.Canvas.Pen.Color := clGray;
  if Color[x, y] = 1 then Image1.Canvas.Brush.Color := clBlue
  else Image1.Canvas.Brush.Color := clYellow;
  Image1.Canvas.Rectangle(x1, y1, x1+CellSize+1, y1+CellSize+1);
end;

procedure TForm1.DrawEmpty(x, y : integer);
var x1, y1 : integer;
begin
  x1 := (x + WorldSizeX) * CellSize;
  y1 := (y + WorldSizeY) * CellSize;
  Image1.Canvas.Pen.Color :=  clBtnFace;
  Image1.Canvas.Brush.Color := clGray;
  Image1.Canvas.Rectangle(x1, y1, x1+CellSize+1, y1+CellSize+1);
end;

procedure TForm1.ClearScreen;
var i1, i2 : integer;
begin
  Image1.Canvas.Pen.Color :=  clBtnFace;
  Image1.Canvas.Brush.Color := clGray;
  Image1.Canvas.Rectangle(-1, -1, 401, 401);
  for i1 := 0 to 2* WorldSizeX  do
  begin
    Image1.Canvas.MoveTo(i1*CellSize, 0);
    Image1.Canvas.LineTo(i1*CellSize, 400);
  end;
  for i2 := 0 to 2* WorldSizeY  do
  begin
    Image1.Canvas.MoveTo(0, i2*CellSize);
    Image1.Canvas.LineTo(400, i2*CellSize);
  end;
  for i2 := -WorldSizeY to WorldSizeY  do
  for i1 := -WorldSizeX to WorldSizeX  do
    if Body[i1, i2] then DrawCell(i1, i2);
end;

procedure TForm1.ClearAll;
var i1, i2 : integer;
begin
  for i2 := -WorldSizeY to WorldSizeY  do
  for i1 := -WorldSizeX to WorldSizeX  do
    if Body[i1, i2] then
    begin
      Die1Cell(i1, i2);
      DieCell(i1, i2);
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var i1, i2 : integer;
begin
  Randomize;
  FileName := '';
  TrackBar1.Position := 10;
  CellSize := TrackBar1.Position;
  WorldSizeX := trunc(400/(2*CellSize));
  WorldSizeY := trunc(400/(2*CellSize));
  ChangeRules;
  Age := 0;
  for i2 := -WorldSizeY-1 to WorldSizeY+1  do
  for i1 := -WorldSizeX-1 to WorldSizeX+1  do
  begin
    Body[i1, i2] := false;
    Future[i1, i2] := false;
    Nears[i1, i2] := 0;
    Color[i1, i2] := 0;
    DrawEmpty(i1, i2);
  end;
  AddGCell(0, 0);
  AddYCell(0, -1);
  AddGCell(-1, 0);
  AddYCell(1, 0);
  AddGCell(-1, 1);
  AddCell(0, 0);
  AddCell(0, -1);
  AddCell(-1, 0);
  AddCell(1, 0);
  AddCell(-1, 1);
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var x1, y1 : integer;
begin
  If Button = mbLeft then
  begin
    x1 := X div CellSize - WorldSizeX;
    y1 := Y div CellSize - WorldSizeY;
    If RadioButtonBlue.Checked then AddGCell(x1, y1)
    else AddYCell(x1, y1);
    AddCell(x1, y1);
  end;
  If Button = mbRight then
  begin
    x1 := X div CellSize - WorldSizeX;
    y1 := Y div CellSize - WorldSizeY;
    Die1Cell(x1, y1);
    DieCell(x1, y1);
  end;
end;

procedure TForm1.ButtonNextClick(Sender: TObject);
begin
  Pepsi;
end;

procedure TForm1.ButtonPlayClick(Sender: TObject);
begin
  Timer1.Enabled := true;
end;

procedure TForm1.Memo1Click(Sender: TObject);
begin
  Memo1.Lines[0] := '   - Ra !!!!!!';
  Memo1.Lines[1] := '       : last-ra@mail.ru';
  Memo1.Lines[2] := '';
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  CellSize := TrackBar1.Position;
  WorldSizeX := trunc(400/(2*CellSize));
  WorldSizeY := trunc(400/(2*CellSize));
  ClearScreen;
end;

procedure TForm1.ButtonResetClick(Sender: TObject);
begin
  Age := 0;
  LabelPepsi.Caption := IntToStr(Age);
  LabelPepsi.Refresh;
end;

procedure TForm1.ButtonExitClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.ButtonNewClick(Sender: TObject);
begin
  ClearAll;
end;

procedure TForm1.ButtonOpenClick(Sender: TObject);
begin
  If OpenDialog1.Execute then
  begin
    FileName := OpenDialog1.FileName;
    MatrOpen;
  end;
end;

procedure TForm1.MatrOpen;
var f : file of char;
    ch : char;
    i1, x1, y1, c1 : integer;
    Sender : TObject;
begin
  Sender := TObject.Create;
  ClearAll;
  AssignFile(f, FileName);
  Reset(f);
  read(f, ch);
  if ch = '1' then RadioButtonBlue.Checked := true
  else RadioButtonBlue.Checked := false;
  read(f, ch);  if ch = '1' then B0.Checked := true;
  read(f, ch);  if ch = '1' then B1.Checked := true;
  read(f, ch);  if ch = '1' then B2.Checked := true;
  read(f, ch);  if ch = '1' then B3.Checked := true;
  read(f, ch);  if ch = '1' then B4.Checked := true;
  read(f, ch);  if ch = '1' then B5.Checked := true;
  read(f, ch);  if ch = '1' then B6.Checked := true;
  read(f, ch);  if ch = '1' then B7.Checked := true;
  read(f, ch);  if ch = '1' then B8.Checked := true;
  read(f, ch);  if ch = '1' then D0.Checked := true;
  read(f, ch);  if ch = '1' then D1.Checked := true;
  read(f, ch);  if ch = '1' then D2.Checked := true;
  read(f, ch);  if ch = '1' then D3.Checked := true;
  read(f, ch);  if ch = '1' then D4.Checked := true;
  read(f, ch);  if ch = '1' then D5.Checked := true;
  read(f, ch);  if ch = '1' then D6.Checked := true;
  read(f, ch);  if ch = '1' then D7.Checked := true;
  read(f, ch);  if ch = '1' then D8.Checked := true;
  ChangeRules;
  read(f, ch);  TrackBar1.Position := ord(ch);  TrackBar1Change(Sender);
  read(f, ch);  Age := ord(ch) * 10000;
  read(f, ch);  Age := Age + ord(ch) * 100;
  read(f, ch);  Age := Age + ord(ch); LabelPepsi.Caption := IntToStr(Age);
  while not Eof(f) do
  begin
    read(f, ch);  i1 := ord(ch);
    if i1 < 4 then c1 := 1 else begin c1 := 2;  i1 := i1 - 4 end;
    if i1 < 2 then y1 := -1 else begin y1 := 1;  i1 := i1 - 2 end;
    if i1 < 1 then x1 := -1 else x1 := 1;
    read(f, ch);  x1 := x1*ord(ch);
    read(f, ch);  y1 := y1*ord(ch);
    if c1 = 1 then AddGCell(x1, y1) else AddYCell(x1, y1);
    AddCell(x1, y1);
  end;
  CloseFile(f);
  Sender.Free;
end;

procedure TForm1.MatrSave;
var f : file of char;
    ch : char;
    i1, i2, i3 : integer;
    li1 : longint;
begin
  AssignFile(f, FileName);
  Rewrite(f);
  if RadioButtonBlue.Checked then ch := '1'
  else ch := '2';  write(f, ch);
  for i1 := 0 to 8 do
  begin
    if B[i1] then ch := '1' else ch := '0';  write(f, ch);
  end;
  for i1 := 0 to 8 do
  begin
    if D[i1] then ch := '1' else ch := '0';  write(f, ch);
  end;
  ch := chr(CellSize);   write(f, ch);
  li1 := Age;  i1 := li1 div 10000;
  ch := chr(i1);  write(f, ch);
  li1 := li1 - i1 * 10000;  i1 := li1 div 100;
  ch := chr(i1);  write(f, ch);
  i1 := li1 - i1 * 100;  ch := chr(i1);  write(f, ch);
  for i2 := -WorldSizeY to WorldSizeY  do
  for i1 := -WorldSizeX to WorldSizeX  do
    if Body[i1, i2] then
    begin
      if i1 < 0 then i3 := 0  else i3 := 1;
      if i2 < 0 then i3 := i3 else i3 := i3 + 2;
      if Color[i1, i2] = 1 then i3 := i3  else i3 := i3 + 4;
      ch := chr(i3);  write(f, ch);
      ch := chr(round(abs(i1)));  write(f, ch);
      ch := chr(round(abs(i2)));  write(f, ch);
    end;
  CloseFile(f);
end;

procedure TForm1.ButtonSaveClick(Sender: TObject);
begin
  if FileName <> '' then MatrSave
  else ButtonSaveAsClick(Sender);
end;

procedure TForm1.ButtonSaveAsClick(Sender: TObject);
begin
  If SaveDialog1.Execute then
  begin
    FileName := SaveDialog1.FileName;
    MatrSave;
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := false;
  Pepsi;
  Timer1.Enabled := true;
end;

procedure TForm1.ButtonPauseClick(Sender: TObject);
begin
  Timer1.Enabled := false;
end;

procedure TForm1.ChangeRules;
begin
  b[0] := B0.checked;  b[1] := B1.checked;  b[2] := B2.checked;
  b[3] := B3.checked;  b[4] := B4.checked;  b[5] := B5.checked;
  b[6] := B6.checked;  b[7] := B7.checked;  b[8] := B8.checked;
  d[0] := d0.checked;  d[1] := d1.checked;  d[2] := d2.checked;
  d[3] := d3.checked;  d[4] := d4.checked;  d[5] := d5.checked;
  d[6] := d6.checked;  d[7] := d7.checked;  d[8] := d8.checked;
end;

procedure TForm1.b4Click(Sender: TObject);
begin
  ChangeRules;
end;

end.
